#version 430 core

layout( local_size_x = 16, local_size_y = 16, local_size_z = 1) in;
layout (rgba32f) uniform image2D tex;

const float kMaxRadius = 10.0;

uniform float zoom;
uniform float time;
uniform int maxIteration;
uniform float offx, offy;

float fractal(vec2 pos)
{
	float r = float(pos.x);
	float im = float(pos.y);
//	float sr = 0.5; // Julia offset
//	float sim = 0.5; // Julia offset
	float radius = 0.0;
	int i;
	
	for (i = 0; i < maxIteration && radius < kMaxRadius; i++)
	{
		float r2, im2;
		r2 = r*r - im*im + offx;
		im2 = 2*r*im + offy;
		r = r2;
		im = im2;
		
		radius = sqrt(r*r + im*im);
	}
	return i;
}


void main (void)
{
    ivec2 pos=ivec2(gl_GlobalInvocationID.x, gl_GlobalInvocationID.y);
    
    vec2 p = pos / 256.0 - 1;
    
    float d = fractal(p * zoom) * 3.0;
    
    imageStore(tex, pos, vec4(cos(d*10),sin(time*5)*0.5+0.5,0.5*sin(d * 20.0)+0.5,1));
}

